<?php
//error_reporting(E_ALL);
//ini_set('display_errors', '1');
require("sipgateAPI.php");
$username = ''; // Your Sipgate username.
if($_POST['email'] !== null) {$username = $_POST['email']; }
$password = ''; // Your Sipgate password.
if($_POST['password'] !== null) {$password = $_POST['password']; }
$sip_id = ''; // SIP-ID of your desk phone.
if($_POST['sip_id'] !== null) {$sip_id = $_POST['sip_id']; }
$sipgate = new Sipgate($username, $password, $sip_id);
//printf(xmlrpc_encode_request())
$r = $sipgate->uris();
//print_r($r);

function sipgate_format_phone($number, $country = false)
{
	$number = preg_replace('/[^0-9+]/', '', (substr($number, 0, 20))); // Remove everything except letters and plusses.
	if (empty($number)) return false;

	if (!$country) return $number; // No country - fingers crossed!
	if (substr($number, 0, 1) == '+') return substr($number, 1); // Already an international number - just trim the plus and don't add any prefixes.

	// Load international dialing rules.
	$rules = array('dial' => '49', 'idd' => '00', 'ndd' => '0');


	if (strlen($rules['ndd']) > 0 && substr($number, 0, strlen($rules['ndd'])) == $rules['ndd']) return $rules['dial'] . substr($number, strlen($rules['ndd'])); // Trim off the national prefix if it's there.
	else return $rules['dial'] . $number; // If it's not, return the international prefix.
}

//$phone = '4917630312977'; // Phone number you want to dial formatted for Sipgate.
if($_POST['phone']) {
	$session = $sipgate->call($_POST['phone'], 10000);
	//echo("Anruf wird gestartet.");
}
if($_POST['cancel']) {
	$sipgate->call_end($_POST['cancel']);
	//echo("Anruf wird gestartet.");
}
if($_POST['text'] && $_POST['textPhone']) {
	$sipgate->text($_POST['textPhone'], $_POST['text'], $_POST['textSender']);
}

if($_POST['session']) {
	echo $sipgate->call_status($_POST['session']);
	return;
}

?>


<!DOCTYPE html>
<head>
	<title>Sipgate-API</title>
	
	<link rel="stylesheet" href="css/bootstrap.css" type="text/css">
	<link rel="stylesheet" href="css/code-prettify.css" type="text/css">
	<link rel="stylesheet" href="css/style.css" type="text/css">
	
	<script type="text/coffeescript" src="js/index.coffee"></script>
	<script type="text/javascript" src="//ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js"></script>
	<script type="text/javascript" src="js/jquery.tablesorter.min.js"></script>
	<script type="text/javascript" src="js/bootstrap-twipsy.js"></script>
	<script type="text/javascript" src="js/bootstrap-popover.js"></script>
	<script type="text/javascript" src="js/bootstrap-alerts.js"></script>
	<script type="text/javascript" src="js/code-prettify/prettify.js"></script>
	<script type="text/javascript" src="js/coffee-script.js"></script>
	<meta http-equiv="Content-type" content="text/html; charset=utf-8">
</head>
<body onload="prettyPrint()">
	<form method="post" id="form">
    <div class="container">
        <div class="content">
            <div class="page-header">
				<h1>Sipgate-API <small>für PHP &amp; JavaScript</small></h1>
			</div>
			<div class="row">
				<!-- <?php echo date('c',strtotime("+ 0 seconds", time())); ?> -->
				<div class="span14">
					<?php if($_POST['phone']) { ?>
					<div class="alert-message block-message fade in" data-alert="alert" id="callConnected">
					  <a class="close" href="#">×</a>
					  <input type="hidden" id="sessionStatus" value="<?php echo $session ?>">
					  <p style="padding-bottom: 10px"><b>Einen Augenblick – Die Verbindung wird nun aufgebaut ...</b></p>
					  <ol>
						  <li>Es wird eine Verbindung zum gewählten Endgerät aufgebaut. <span class="label success finish" id="status_1">✓</span></li>
						  <li>Sie nehmen den Anruf an. <span class="label success" id="status_2">Klingelt ...</span></li>
						  <li>Sie werden sofort mit <b><?php echo $_POST['phone'] ?></b> verbunden. <span class="label success" id="status_3">Klingelt ...</span></li>
					  </ol>
					  <div class="alert-actions">
					    <a class="btn small danger" href="#" onclick="$('#form').submit();return false;">Anruf beenden</a>
						<input name="cancel" value="<?php echo $session ?>" type="hidden">
					  </div>
					</div>
					<div class="alert-message error fade in" data-alert="alert" style="display:none" id="callDisconnected">
					  <a class="close" href="#">×</a>
					  
					  <p><b>Der Anruf wurde beendet.</b></p>
					</div>
					
					<?php } ?>
					<?php if($_POST['cancel']) { ?>
					<div class="alert-message error fade in" data-alert="alert">
					  <a class="close" href="#">×</a>
					  
					  <p><b>Der Anruf wurde beendet.</b></p>
					</div>
					
					<?php } ?>
					<?php if($_POST['text'] && $_POST['textPhone']) { ?>
					<div class="alert-message success fade in" data-alert="alert">
					  <a class="close" href="#">×</a>
					  
					  <p><b>Die SMS-Nachricht wurde an <?php echo $_POST['textPhone'] ?> gesendet.</b></p>
					</div>
					
					<?php } ?>
					
					
					<h2>PHP-Bibliothek</h2>
				</div>
			</div>
			<div class="row">
				<div class="span5">
					<h3>Einrichtung der Sipgate-API</h3>
				</div>
				<div class="span9">
					
					<h4>Bibliothek einbinden</h4>
					<p>Zu Beginn muss die API-Bibliothek in die entsprechende PHP-Seite eingebunden werden. Anschließend wird ein <code class="prettyprint">new Sipgate()</code>-Objekt mit den Zugangsdaten erstellt.</p>
					<p>Die Email-Adresse und das Passwort entsprechen den Zugangsdaten, die auch im Webinterface von <a href="https://secure.live.sipgate.de/signin/team">Sipgate Team</a> verwendet werden.</p>
					
					<pre class="prettyprint">require('<span rel="twipsy" data-original-title="Pfad zur API-Bibliothek" data-placement="below">sipgateAPI.php</span>');
$sipgate = new Sipgate('<span class="email str">EMAIL-ADRESSE</span>', '<span class="password str">PASSWORT</span>', '<span class="sip_id str" rel="twipsy" data-original-title="Eindeutige ID des Endgerätes" data-placement="below">SIP-ID</span>');</pre>
					
					
					<h4>Zugangsdaten</h4>
					
						<div class="clearfix">
							<label for="mail">Email-Adresse</label>
							<div class="input">
								<input id="mail" name="email" value="<?php echo $username; ?>">
							</div>
						</div>
						<div class="clearfix">
							<label for="password">Passwort</label>
							<div class="input">
								<input id="password" type="password" name="password" value="<?php echo $password; ?>">
							</div>
						</div>
						<div class="clearfix">
							<div class="input">
								<input type="submit" value="Zugangsdaten anwenden" class="btn">
							</div>
						</div>
					
						
					
					<h4>Die SIP-ID</h4>
					<p>Die SIP-ID ist die eindeutige Kennzeichnung des Endgerätes, das als Basis für ausgehende Anrufe genutzt werden soll.</p>

					<h5>Liste der verfügbaren Sipgate-Endgeräte:</h5>
					<?php if($sipgate->uris()) { ?>
					<table class="zebra-striped" id="sip_ids">
						<thead>
						<tr>
							<th class="yellow"></th><th class="yellow">Bezeichnung</th><th class="blue">Ausg. Rufnummer</th><th class="blue">SIP-ID</th>
						</tr>
						</thead>
						<tbody>
						<?php 
							foreach($sipgate->uris() as $i=>$value) {
								preg_match("/sip:(\S*)@sipgate.de/",$value["SipUri"], $sipid);
								echo "<tr><td><input type='radio' name='sip_id' id='".$sipid[1]."' value='".$sipid[1]."' ";
								if($sip_id !== '') {
									if($sip_id == $sipid[1]) echo "checked";
								} else {
									if ($i == 0) echo "checked";
								}
								echo "></td><td><label for='".$sipid[1]."'>".$value["UriAlias"]."</label></td>";
								echo "<td><label for='".$sipid[1]."'>".$value["E164Out"]."</label></td>";
								echo "<td><label for='".$sipid[1]."'>".$sipid[1]."</label></td></tr>";
							}
						?>
					</tbody>
					</table>
					<?php } else { ?>
						<p class="help-block">
							<b>Hinweis: </b>Um eine Liste der Endgeräte anzuzeigen, müssen die Zugangsdaten ausgefüllt und angewendet werden.
						</p> 
					<?php } ?>
				</div>
			</div>
			<div class="row">
				<div class="span5">
					<h3>Telefonanrufe</h3>
				</div>
				<div class="span9">
					<h4>Telefonanruf einleiten <span class="label warning">call ( )</span></h4>
					<p>Nachdem bereits bei der Einrichtung das Endgerät ausgewählt wurde, muss jetzt nur noch die gewünschte Rufnummer an die <code>$sipgate->call()</code>-Funktion übermittelt werden. Der Anruf wird dann sofort oder mit einer Verzögerung gestartet.</p>
					 
					<pre class="prettyprint"><span rel="twipsy" data-original-title="Gibt die Session-ID zurück" data-placement="below">$session</span> = $sipgate->call('<span class="phone str">RUFNUMMER</span>', '<span rel="twipsy" data-original-title="<b>Optional:</b> Zeit bis zum Start des Anrufs" data-placement="below" data-html="true">VERZÖGERUNG</span>');</pre>
					
					<h6>Beispiel: Rückrufformular</h6>
					<?php if($sipgate->uris()) { ?>
					<div class="clearfix">
					  <input name="phone" placeholder="+49 (0) 4331 123 456" id="phone">
					  <input type="submit" value="Rückruf veranlassen" class="btn primary">
					</div>
					<?php } else { ?>
						<div class="clearfix">
						  <input name="phone" placeholder="+49 (0) 4331 123 456" id="phone" disabled>
						  <input type="submit" value="Rückruf veranlassen" class="btn" disabled>
						</div>
						
						<p class="help-block">
							<b>Hinweis: </b>Um dieses Beispiel nutzen zu können, müssen die Zugangsdaten ausgefüllt und angewendet werden.
						</p> 
					<?php } ?>
					
					
					<pre class="prettyprint">if ($_POST['phone'] !== null) {
  $sipgate->call($_POST['phone']);
}</pre>
					
					<pre class="prettyprint">&lt;form method=&quot;post&quot;&gt;
  &lt;input name=&quot;phone&quot;&gt;
  &lt;input type=&quot;submit&quot; value=&quot;R&uuml;ckruf veranlassen&quot;&gt;
&lt;/form&gt;</pre>
					
					<h4>Anrufstatus abfragen <span class="label warning">call_status ( )</span></h4>
					<p>Zuerst klingelt das Engerät und sobald dort angenommen wird, klingelt es bei der ausgewählten Rufnummer. Um festzustellen, ob der Anruf angenommen oder abgelehnt wurde, kann der Status eines konkreten Anrufs abgefragt werden.</p> 
					
					<h4>Telefonanruf beenden <span class="label warning">call_end ( )</span></h4>
					<p>Ein Telefonanruf kann jederzeit beendet werden, indem die aktuelle Session-ID an die <code>$sipgate->call_end()</code>-Funktion übergeben wird. Die Session-ID wird von der <code>$sipgate->call()</code>-Funktion zurückgegeben.</p> 
					<pre class="prettyprint">$sipgate->call_end(<span rel="twipsy" data-original-title="Session wird von call( ) zurückgegeben" data-placement="below">$session</span>);</pre>
					
				</div>
			</div>
			<div class="row">
				<div class="span5">
					<h3>Textnachrichten</h3>
				</div>
				<div class="span9">
					<h4>Textnachricht senden <span class="label warning">text ( )</span></h4>
					<p>Mit der <code>$sipgate->text()</code>-Funktion können SMS-Nachrichten an eine oder gleichzeitig mehrere belibige Rufnummer/n gesendet werden. Es kann eine <a href="https://secure.live.sipgate.de/sms">verifizierte</a> Absenderrufnummer angegeben werden, ansonsten wird standardmäßig <code>sipgate</code> als Absender verwendet. Die SMS wird dann sofort oder mit einer Verzögerung versendet.</p>
					<pre class="prettyprint">$sipgate->text(
  '<span class="textPhone str">RUFNUMMER</span>','<span class="text str">NACHRICHT</span>', '<span rel="twipsy" data-original-title="<b>Optional:</b>  Absenderrufnummer" data-placement="below" data-html="true" class="textSender str">ABSENDER</span>', '<span rel="twipsy" data-original-title="<b>Optional:</b> Zeit bis zum Start des Anrufs" data-placement="below" data-html="true">VERZÖGERUNG</span>'
);</pre>
					<h6>Beispiel: SMS-Formular</h6>
					<?php if($sipgate->uris()) { ?>
					<div class="clearfix">
					  <textarea name="text" placeholder="Nachricht" id="text" rows="3" class="span9"></textarea><br>
					 </div>
					 <div class="clearfix">
					  <input name="textPhone" placeholder="Rufnummer" id="textPhone" style="width: 184px; margin-right: 5px"><input name="textSender" placeholder="Absenderrufnummer" id="textSender" style="width: 184px">
					  <input type="submit" value="SMS versenden" class="btn primary">
					</div>
					<?php } else { ?>
						<div class="clearfix">
						  <textarea name="text" placeholder="Nachricht" id="text" rows="3" class="span9" disabled></textarea><br>
						 </div>
						 <div class="clearfix">
						  <input name="textPhone" placeholder="Rufnummer" id="textPhone" style="width: 184px; margin-right: 5px" disabled><input name="textSender" placeholder="Absenderrufnummer" id="textSender" style="width: 184px" disabled>
						  <input type="submit" value="SMS versenden" class="btn" disabled>
						</div>
						
						
						<p class="help-block">
							<b>Hinweis: </b>Um dieses Beispiel nutzen zu können, müssen die Zugangsdaten ausgefüllt und angewendet werden.
						</p> 
					<?php } ?>
					
				</div>
			</div>
			<div class="row">
				<div class="span5">
					<h3>Events</h3>
				</div>
				<div class="span9">
					<h4>Voicemails &amp; Faxe ausgeben <span class="label warning">event_list ( )</span></h4>
					<p>Gibt alle Mailbox-Nachichten und Faxe des Sipgate-Kontos in einem bestimmten Zeitraum als Liste zurück. </p>
					<!-- <p><span class="label notice">AccountStatementChargedServices</span>, <span class="label notice">PeriodStart</span>, <span class="label notice">BalanceStart</span>, <span class="label notice">PeriodEnd</span>, <span class="label notice">BalanceEnd</span></p> -->
					<pre class="prettyprint">$list = $sipgate->event_list('STARTDATUM', 'ENDDATUM', 'LABELS', 'TYP', 'LIMIT', 'OFFSET', 'EVENT_IDS', 'START_EVENT');</pre>
					<h6>Beispiel: Die letzten 5 Voicemails / Faxe</h6>
					<?php if($sipgate->uris()) { ?>
					<table class="zebra-striped" id="event_list">
						<thead>
						<tr>
							<th class="red">Typ</th><th class="blue right">Absender</th><th class="green right">Empfänger</th><th class="purple right">Dauer</th><th class="yellow right">Datum</th>
						</tr>
						</thead>
						<tbody>
						<?php
							$list = $sipgate->event_list(0, false, array(), array(), 0);
							foreach($list['EventList'] as $i=>$value) {
								echo "<tr><td><a href='".$value['ContentList'][0]['DownloadUriHttp']."' target='_blank'>";
								if($value['TOS'] == 'voice') echo "<img src='images/balloon-sound.png' title='Voicemail' alt='Voicemail'>";
								else if ($value['TOS'] == 'fax') echo "<img src='images/telephone-fax.png' title='Fax' alt='Fax'>";
								echo "</a></td><td class='right'><span style='display: inline-block; width: 110px; overflow: hidden;white-space:nowrap;'>".preg_replace('/(tel:)([0-9]{2})([0-9]{3})([0-9]{4})/', '0$3-$4', $value['SourceUri'])."</span></td>";
								echo "<td class='right'><span style='display: inline-block; width: 110px; overflow: hidden;white-space:nowrap;'>".preg_replace('/(tel:)([0-9]{2})([0-9]{3})([0-9]{4})/', '0$3-$4', $value['TargetUri'])."</span></td>";
								echo "<td class='right'>".$value['SizeDepend']."</td>";
								echo "<td class='right'>".date('d.m.y H:i', strtotime($value['Timestamp']))."</td></tr>";
							}
						?>
					</tbody>
					</table>
					<?php } else { ?>
						<p class="help-block">
							<b>Hinweis: </b>Um dieses Beispiel nutzen zu können, müssen die Zugangsdaten ausgefüllt und angewendet werden.
						</p> 
						
					<?php } ?>
					
					<br><br>
					
				</div>
			</div>
			<div class="row">
				<div class="span5">
					<h3>Weitere Funktionen</h3>
				</div>
				<div class="span9">
					<h4>Aktuelles Guthaben abfragen <span class="label warning">balance ( )</span></h4>
					<p>Gibt das altuelle Sipgate-Guthaben als Euro zurück.</p>
					<pre class="prettyprint">$balance = $sipgate->balance();</pre>
					<h6>Beispiel:</h6>
					<?php if($sipgate->uris()) { 
						echo "Aktuelles Guthaben: <code>".number_format($sipgate->balance(), 2, ',', '.')." €</code><br>"; 
				 	} else { ?>
						<p class="help-block">
							<b>Hinweis: </b>Um dieses Beispiel nutzen zu können, müssen die Zugangsdaten ausgefüllt und angewendet werden.
						</p> 
						
					<?php } ?>
					<br><br>
					<h4>Alle Rechnungsposten ausgeben <span class="label warning">account_statement ( )</span></h4>
					<p>Gibt alle Rechnungsposten des Sipgate-Kontos in einem bestimmten Zeitraum als Liste zurück. </p>
					<!-- <p><span class="label notice">AccountStatementChargedServices</span>, <span class="label notice">PeriodStart</span>, <span class="label notice">BalanceStart</span>, <span class="label notice">PeriodEnd</span>, <span class="label notice">BalanceEnd</span></p> -->
					<pre class="prettyprint">$account = $sipgate->account_statement('STARTDATUM', 'ENDDATUM');</pre>
					<h6>Beispiel:</h6>
					<?php if($sipgate->uris()) { ?>
					<table class="zebra-striped" id="account">
						<thead>
						<tr>
							<th class="yellow">Bezeichnung</th><th class="blue right">Preis</th><th class="green right">Dauer</th><th class="red right">Anzahl</th>
						</tr>
						</thead>
						<tbody>
						<?php
							$account = $sipgate->account_statement();
							foreach($account['AccountStatementChargedServices'] as $i=>$value) {
								if($value['Price']['TotalIncludingVat'] != 0) {
									echo "<tr><td>".$value['ServiceName']."</td>";
									echo "<td class='right'>".number_format($value['Price']['TotalIncludingVat'], 2, ',', '.').' €'."</td>";
									echo "<td class='right'>".$value['TotalDuration']."</td>";
									echo "<td class='right'>".$value['Quantity']."</td></tr>";
								}
							}
						?>
					</tbody>
					</table>
					<?php } else { ?>
						<p class="help-block">
							<b>Hinweis: </b>Um dieses Beispiel nutzen zu können, müssen die Zugangsdaten ausgefüllt und angewendet werden.
						</p> 
						
					<?php } ?>
					
					<br><br>
					<h4>Alle Endgeräte anzeigen <span class="label warning">uris ( )</span></h4>
					<p>Alle verfügbaren Engeräte können mit der <code>$sipgate->uris()</code>-Funktion als Liste ausgegeben werden.</p>
					<pre class="prettyprint">foreach($sipgate->uris() as $sip) {
  $id = $sip["SipUri"]
  $title = $sip["UriAlias"]
  $number_in = $sip["E164Out"]
  $number_out = $sip["E164In"]
  $type = $sip["TOS"]
}</pre>
					<h6>Beispiel:</h6>
					<p class="help-block">Siehe weiter oben unter: <b>Liste der verfügbaren Sipgate-Endgeräte</b>.</p> 
					
					<br><br>
					<h4>Alle API-Funktionen ausgeben <span class="label warning">list_methods ( )</span></h4>
					<p>Gibt alle verfügbaren Funktionen der Sipgate-API zurück.</p>
					<pre class="prettyprint">$methods = $sipgate->list_methods();</pre>
					<h6>Beispiel:</h6>
					<?php if($sipgate->uris()) { ?>
					<table class="zebra-striped" id="methods">
						<thead>
						<tr>
							<th class="yellow">Bezeichnung</th>
						</tr>
						</thead>
						<tbody>
						<?php
							foreach($sipgate->list_methods() as $i=>$value) {
								echo "<tr><td>".$value."</td></tr>";
							}
						?>
					</tbody>
					</table>
					<?php } else { ?>
						<p class="help-block">
							<b>Hinweis: </b>Um dieses Beispiel nutzen zu können, müssen die Zugangsdaten ausgefüllt und angewendet werden.
						</p> 
						
					<?php } ?>
					
				</div>
			</div>
			
		</div>
        <footer class="footer">
            <p>
                Riverlabs GmbH <small>•</small> <a href="https://www.riverlabs.de">Impressum</a> <br> 
                <small>Alle Angaben ohne Gewähr.</small>
            </p>
        </footer>
	</div>
</body>